// DECALS
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _663
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1137
{
    int _m0;
    int _m1;
};

struct _1140
{
    int _m0;
    int _m1;
};

struct _1251
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2105
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _2880
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _3574
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _684_686
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _686;

layout(set = 2, binding = 0, std140) uniform _787_789
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
} _789;

layout(set = 1, binding = 0, std140) uniform _973_975
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
} _975;

layout(set = 0, binding = 12, std430) restrict readonly buffer _1142_1144
{
    _1140 _m0[];
} _1144;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1226_1228
{
    uint _m0[];
} _1228;

layout(set = 0, binding = 14, std140) uniform _1256_1258
{
    vec4 _m0[4096];
} _1258;

layout(set = 0, binding = 15, std140) uniform _1276_1278
{
    vec4 _m0[4096];
} _1278;

layout(set = 0, binding = 16, std140) uniform _1328_1330
{
    vec4 _m0[4096];
} _1330;

layout(set = 0, binding = 18, std140) uniform _2109_2111
{
    vec4 _m0[4096];
} _2111;

layout(set = 0, binding = 19, std140) uniform _2148_2150
{
    vec4 _m0[4096];
} _2150;

layout(set = 0, binding = 20, std140) uniform _2217_2219
{
    vec4 _m0[3072];
} _2219;

layout(set = 0, binding = 22, std140) uniform _2884_2886
{
    vec4 _m0[4095];
} _2886;

layout(set = 0, binding = 24, std140) uniform _3578_3580
{
    vec4 _m0[4096];
} _3580;

layout(set = 0, binding = 1, std430) restrict readonly buffer _4102_4104
{
    vec4 _m0[];
} _4104;

layout(push_constant, std430) uniform _4098_4100
{
    int _m0;
    int _m1;
} _4100;

layout(set = 3, binding = 3) uniform TEXTURE_2D _814[8];
layout(set = 0, binding = 5) uniform sampler _821;
layout(set = 3, binding = 2) uniform TEXTURE_2D _865[8];
layout(set = 0, binding = 6) uniform sampler _869;
layout(set = 3, binding = 0) uniform TEXTURE_2D _880[8];
layout(set = 0, binding = 7) uniform sampler _884;
layout(set = 3, binding = 1) uniform TEXTURE_2D _895[8];
layout(set = 0, binding = 8) uniform sampler _899;
layout(set = 3, binding = 7) uniform TEXTURE_2D _909[8];
layout(set = 0, binding = 9) uniform sampler _913;
layout(set = 3, binding = 4) uniform TEXTURE_2D _922[8];
layout(set = 0, binding = 10) uniform sampler _926;
layout(set = 3, binding = 6) uniform TEXTURE_2D _935[8];
layout(set = 0, binding = 11) uniform sampler _939;
layout(set = 0, binding = 17) uniform SAMPLER_2D _1550;
layout(set = 0, binding = 21) uniform SAMPLER_2D _2443;
layout(set = 0, binding = 23) uniform sampler2DShadow _3206;
layout(set = 0, binding = 25) uniform SAMPLER_2D _3719;
layout(set = 0, binding = 26) uniform SAMPLER_2D _3904;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4097[8];
layout(set = 0, binding = 3) uniform sampler3D _4108;
layout(set = 0, binding = 4) uniform sampler3D _4109;

layout(location = 2) in vec4 _677;
layout(location = 6) in vec4 _691;
layout(location = 3) in vec4 _703;
layout(location = 4) in vec4 _706;
layout(location = 5) in vec4 _709;
layout(location = 10) in vec4 _727;
layout(location = 11) in vec4 _731;
layout(location = 12) in vec4 _735;
layout(location = 14) flat in uvec3 _748;
layout(location = 15) in vec4 _751;
layout(location = 0) out vec4 _4055;
layout(location = 1) out vec4 _4063;
layout(location = 2) out vec4 _4071;

uvec4 _32(vec4 _31)
{
    return floatBitsToUint(_31);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _127(float _123, vec4 _124, float _125, bool _126)
{
    float _518 = _124.w / (_123 + _124.z);
    return _518 * _125;
}

vec3 _132(vec3 _130, bool _131)
{
    vec3 _531 = (_130 * 2.0) - vec3(1.0);
    float _548 = (1.0 - (_531.x * _531.x)) - (_531.y * _531.y);
    _531.z = sqrt(_10(_548));
    if (_131 == false)
    {
        _531.z = -_531.z;
    }
    return _531;
}

vec3 _139(vec3 _137, mat3 _138)
{
    return normalize(vec3(dot(_137, _138[0]), dot(_137, _138[1]), dot(_137, _138[2])));
}

uint _27(float _26)
{
    return floatBitsToUint(_26);
}

float _43(float _40, float _41, float _42)
{
    return min(_40, min(_41, _42));
}

float _38(float _35, float _36, float _37)
{
    return max(_35, max(_36, _37));
}

vec4 _77(uint _76)
{
    return unpackUnorm4x8(_76).wzyx;
}

vec4 _90(uvec2 _89)
{
    return vec4(float((_89.x >> uint(16)) & 65535u), float(_89.x & 65535u), float((_89.y >> uint(16)) & 65535u), float(_89.y & 65535u)) * 3.0518509447574615478515625e-05;
}

vec4 _102(SAMPLER_2D _98, vec2 _99, vec2 _100, vec2 _101)
{
    return TEXTURE_GRAD(_98, _99, _100, _101);
}

float _52(float _51)
{
    return _51 * ((_51 * ((_51 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _80(uint _79)
{
    return vec4(float((_79 >> uint(24)) & 255u), float((_79 >> uint(16)) & 255u), float((_79 >> uint(8)) & 255u), float(_79 & 255u));
}

vec3 _55(vec3 _54)
{
    float _252 = _54.x;
    vec3 _251;
    _251.x = _52(_252);
    float _258 = _54.y;
    _251.y = _52(_258);
    float _264 = _54.z;
    _251.z = _52(_264);
    return _251;
}

vec4 _58(vec4 _57)
{
    vec3 _274 = _57.xyz;
    vec4 _273 = vec4(_55(_274), 1.0);
    float _282 = _57.w;
    _273.w = _52(_282);
    return _273;
}

float _69(float _68)
{
    return (step(0.0, _68) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _84(uint _83)
{
    return vec3(float((_83 >> uint(21)) & 2047u), float((_83 >> uint(10)) & 2047u), float(_83 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _49(float _46, float _47, float _48)
{
    bool _197 = abs(_48) >= abs(_46);
    bool _205;
    if (_197)
    {
        _205 = abs(_48) >= abs(_47);
    }
    else
    {
        _205 = _197;
    }
    if (_205)
    {
        return uint((_48 < 0.0) ? 5 : 4);
    }
    if (abs(_47) >= abs(_46))
    {
        return uint((_47 < 0.0) ? 3 : 2);
    }
    return uint(int(_46 < 0.0));
}

float _61(float _60)
{
    return exp2(_60);
}

vec3 _105(uint _104)
{
    uint _392 = _104;
    vec4 _391 = _77(_392);
    float _403 = (_391.w * 255.0) - 128.0;
    return _391.xyz * _61(_403);
}

float _66(float _64, float _65)
{
    return pow(_64, _65);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _110(vec3 _108, float _109)
{
    float _415 = 50.0 * dot(_108, vec3(0.33329999446868896484375));
    float _408 = _10(_415);
    float _424 = 1.0 - _109;
    float _427 = _10(_424);
    float _428 = 5.0;
    vec3 _432 = _108 + ((vec3(_408) - _108) * _66(_427, _428));
    return _16(_432);
}

vec3 _118(vec3 _113, vec3 _114, vec3 _115, vec3 _116, float _117)
{
    vec3 _436 = normalize(_114 + _115);
    float _441 = 1.0 - (_117 * 0.800000011920928955078125);
    _441 *= _441;
    _441 *= _441;
    float _452 = _441 * _441;
    float _460 = dot(_113, _436);
    float _456 = _10(_460);
    float _462 = ((_456 * _456) * (_452 - 1.0)) + 1.0;
    _462 = _452 / ((_462 * _462) + 9.9999999392252902907785028219223e-09);
    float _481 = dot(_113, _114);
    float _477 = (_10(_481) * (1.0 - _441)) + _441;
    float _492 = dot(_113, _115);
    float _488 = (_10(_492) * (1.0 - _441)) + _441;
    _462 /= (((4.0 * _477) * _488) + 9.9999999392252902907785028219223e-09);
    vec3 _510 = _116;
    float _512 = dot(_115, _436);
    return _110(_510, _512) * _462;
}

vec2 _143(vec2 _142)
{
    return (vec2(1.0) - abs(_142.yx)) * vec2((_142.x >= 0.0) ? 1.0 : (-1.0), (_142.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _148(inout vec3 _146, bool _147)
{
    _146 /= vec3((abs(_146.x) + abs(_146.y)) + abs(_146.z));
    vec2 _615;
    if (_146.z >= 0.0)
    {
        _615 = _146.xy;
    }
    else
    {
        vec2 _621 = _146.xy;
        _615 = _143(_621);
    }
    _146 = vec3(_615.x, _615.y, _146.z);
    if (_147)
    {
        vec2 _636 = (_146.xy * 0.5) + vec2(0.5);
        _146 = vec3(_636.x, _636.y, _146.z);
    }
    return _146.xy;
}

float _72(float _71)
{
    return sqrt(_71);
}

float _151(float _150)
{
    float _646 = abs(_150);
    float _643 = _72(_646);
    float _650;
    if (_150 > 0.0)
    {
        _650 = _643;
    }
    else
    {
        _650 = -_643;
    }
    return (_650 * 0.5) + 0.5;
}

void main()
{
    _663 _665 = _663(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _665._m15 = _677;
    _665._m16 = gl_FragCoord;
    _665._m14 = _686._m2.xyz + _691.xyz;
    _665._m13 = normalize(-_691.xyz);
    _665._m17 = mat3(vec3(_703.xyz), vec3(_706.xyz), vec3(_709.xyz));
    _665._m34 = _727;
    _665._m35 = _731;
    _665._m36 = _735;
    uint _738 = 0u;
    vec4 _739 = vec4(0.0);
    vec4 _740 = vec4(0.0);
    vec4 _741 = vec4(0.0);
    vec4 _742 = vec4(0.0);
    vec4 _743 = vec4(0.0);
    uvec3 _746 = _748;
    vec3 _750 = _751.xyz;
    bool _757 = _746.y == 65535u;
    bool _763;
    if (_757)
    {
        _763 = _746.z == 65535u;
    }
    else
    {
        _763 = _757;
    }
    bool _754 = _763;
    bool _764 = !_754;
    bool _767 = _746.z != 65535u;
    uint _771 = _746.x & 7u;
    uint _782;
    if (_686._m4.x == 0.0)
    {
        _782 = _771;
    }
    else
    {
        vec4 _790 = _789._m4;
        uvec4 _786 = _32(_790);
        uint _794 = _786[_771 / 2u];
        uint _799 = 16u * (_771 & 1u);
        _782 = (_794 >> _799) & 65535u;
    }
    uint _808 = _782;
    float _810 = SAMPLE_TEXTURE(SAMPLER_2D(_814[_808], _821), _665._m15.zw).x;
    float _840 = pow(_810, 0.125) - 0.800000011920928955078125;
    vec2 _829 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_840) / 0.20000000298023223876953125));
    vec2 _848 = dFdx(_665._m15.zw) * _829.x;
    vec2 _856 = dFdy(_665._m15.zw) * _829.y;
    vec2 _864 = TEXTURE_GRAD(SAMPLER_2D(_865[_808], _869), _665._m15.zw, _848, _856).yx;
    vec3 _879 = SAMPLE_TEXTURE(SAMPLER_2D(_880[_808], _884), _665._m15.zw).xyz;
    vec3 _892 = vec3(0.039999999105930328369140625);
    _892 = SAMPLE_TEXTURE(SAMPLER_2D(_895[_808], _899), _665._m15.zw).xyz;
    float _907 = 1.0;
    float _908 = SAMPLE_TEXTURE(SAMPLER_2D(_909[_808], _913), _665._m15.zw).x;
    float _921 = SAMPLE_TEXTURE(SAMPLER_2D(_922[_808], _926), _665._m15.zw).x;
    vec3 _934 = SAMPLE_TEXTURE(SAMPLER_2D(_935[_808], _939), _665._m15.zw).xyz;
    _741 = vec4(_879.x, _879.y, _879.z, _741.w);
    _741.w = _864.y;
    _742 = vec4(_892.x, _892.y, _892.z, _742.w);
    _742.w = _921;
    _743 = vec4(_743.x, _864.x, _743.z, _864.y);
    _739.x = _908;
    _739.y = _907;
    _739.z = _921;
    _739.w = _810;
    _740 = vec4(_934.x, _934.y, _934.z, _740.w);
    vec3 _972 = (_975._m8.xyz * _789._m5.xyz) * mix(_741.xyz, vec3(1.0), vec3(_975._m8.w));
    _665._m10 = vec3(((_789._m6.x * _739.x) * _739.x) * _975._m9.x) * _972;
    _665._m10 *= vec3(_686._m5.x);
    _665._m0 = _741.xyz;
    _665._m2 = _742.xyz;
    _665._m1 = _740.xyz;
    _665._m9 = _739.xyz;
    _665._m3 = _739.w;
    _665._m6 = _743.wyz;
    uint _1033 = uint((_975._m10.x > 0.0) ? 8 : 0);
    float _1039 = 16.0;
    float _1041 = 8.0;
    float _1043 = 24.0;
    vec2 _1052 = _665._m16.xy * _686._m6.xy;
    vec3 _1045;
    _1045 = vec3(_1052.x, _1052.y, _1045.z);
    _1045.y = 1.0 - _1045.y;
    
     // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1045.x -= vk3d_params[VIEW].stereo.x * 0.5;
    
    vec2 _1065 = floor(_1045.xy * vec2(_1039, _1041));
    _1045 = vec3(_1065.x, _1065.y, _1045.z);
    float _1070 = _665._m16.z;
    vec4 _1073 = _686._m7;
    float _1076 = 1.0;
    bool _1077 = false;
    float _1068 = _127(_1070, _1073, _1076, _1077);
    float _1079 = log2(max(1.0, _1068 / _686._m8.z)) * _686._m8.w;
    _1045.z = min(_1043 - 1.0, floor(_1079));
    uint _1095 = uint((_1045.x + (_1045.y * _1039)) + ((_1045.z * _1039) * _1041));
    bool _1111 = true;
    vec3 _1113 = _665._m6;
    bool _1116 = _1111;
    _665._m7 = _132(_1113, _1116);
    vec3 _1120 = _665._m7;
    mat3 _1123 = _665._m17;
    _665._m6 = _139(_1120, _1123);
    uint _1128 = 0u;
    uint _1129 = 0u;
    uint _1130 = 0u;
    uint _1131 = 0u;
    uint _1132 = 0u;
    uint _1133 = 0u;
    int _1135 = 256;
    _1137 _1139;
    _1139._m0 = _1144._m0[_1095]._m0;
    _1139._m1 = _1144._m0[_1095]._m1;
    int _1153 = _1139._m0 & (~(_1139._m0 >> 31));
    int _1162 = _1139._m1 & (~(_1139._m1 >> 31));
    _1128 = uint((_1153 >> 16) * _1135);
    _1129 = _1128 + uint(_1162 & 255);
    _1130 = _1128;
    _1131 = _1130 + uint((_1162 >> 8) & 255);
    _1132 = _1128;
    _1133 = _1132 + uint((_1162 >> 16) & 255);
    vec3 _1195 = dFdx(_665._m14);
    vec3 _1199 = dFdy(_665._m14);
    bool _1204 = _1033 == 0u;
    bool _1210;
    if (_1204)
    {
        _1210 = _975._m10.y == 0.0;
    }
    else
    {
        _1210 = _1204;
    }
    _1130 = _1210 ? _1131 : _1130;
    uint _1214 = _1130;
    _1251 _1253;
    vec3 _1607;
    float _1740;
    while (_1214 < _1131)
    {
        uint _1224 = _1228._m0[_1214];
        uint _1233 = (_1224 >> uint(12)) & 4095u;
        uint _1239 = _1233;
        if (_1239 >= _1233)
        {
            _1214++;
        }
        int _1248 = 2;
        int _1249 = 2;
        int _1250 = 2;
        _1253._m0 = _1258._m0[(uint(_1248) * _1239) + 0u];
        _1253._m1 = _1258._m0[(uint(_1248) * _1239) + 1u];
        _1253._m2 = _1278._m0[(uint(_1249) * _1239) + 0u];
        float _1292 = _1278._m0[(uint(_1249) * _1239) + 1u].x;
        _1253._m3.x = _27(_1292);
        float _1302 = _1278._m0[(uint(_1249) * _1239) + 1u].y;
        _1253._m3.y = _27(_1302);
        float _1312 = _1278._m0[(uint(_1249) * _1239) + 1u].z;
        _1253._m4.x = _27(_1312);
        float _1322 = _1278._m0[(uint(_1249) * _1239) + 1u].w;
        _1253._m4.y = _27(_1322);
        float _1336 = _1330._m0[(uint(_1250) * _1239) + 0u].x;
        _1253._m5.x = _27(_1336);
        float _1346 = _1330._m0[(uint(_1250) * _1239) + 0u].y;
        _1253._m5.y = _27(_1346);
        float _1356 = _1330._m0[(uint(_1250) * _1239) + 0u].z;
        _1253._m6 = _27(_1356);
        float _1366 = _1330._m0[(uint(_1250) * _1239) + 0u].w;
        _1253._m7 = _27(_1366);
        float _1376 = _1330._m0[(uint(_1250) * _1239) + 1u].x;
        _1253._m8 = _27(_1376);
        float _1386 = _1330._m0[(uint(_1250) * _1239) + 1u].y;
        _1253._m9 = _27(_1386);
        float _1396 = _1330._m0[(uint(_1250) * _1239) + 1u].z;
        _1253._m10 = _27(_1396);
        float _1407 = _1330._m0[(uint(_1250) * _1239) + 1u].w;
        _1253._m11 = _27(_1407);
        vec4 _1412 = _1253._m0;
        vec4 _1415 = _1253._m2;
        vec4 _1418 = _1253._m1;
        vec4 _1421 = vec4(_665._m14, 1.0);
        vec3 _1428 = vec3(dot(_1421, _1412), dot(_1421, _1418), dot(_1421, _1415));
        float _1439 = 0.0039215688593685626983642578125;
        float _1441 = _1428.x;
        float _1444 = _1428.y;
        float _1447 = _1428.z;
        bool _1452 = _43(_1441, _1444, _1447) <= _1439;
        bool _1469;
        if (!_1452)
        {
            float _1456 = _1428.x;
            float _1459 = _1428.y;
            float _1462 = _1428.z;
            _1469 = _38(_1456, _1459, _1462) >= (1.0 - _1439);
        }
        else
        {
            _1469 = _1452;
        }
        if (_1469)
        {
            continue;
        }
        uint _1473 = _1253._m11;
        bool _1477 = _1033 != 0u;
        bool _1484;
        if (_1477)
        {
            _1484 = (_1473 & 512u) != 0u;
        }
        else
        {
            _1484 = _1477;
        }
        bool _1497;
        if (!_1484)
        {
            bool _1489 = _1033 == 0u;
            bool _1496;
            if (_1489)
            {
                _1496 = (_1473 & 1024u) != 0u;
            }
            else
            {
                _1496 = _1489;
            }
            _1497 = _1496;
        }
        else
        {
            _1497 = _1484;
        }
        if (_1497)
        {
            continue;
        }
        vec2 _1501 = vec2(dot(_1195, _1412.xyz), dot(_1195, _1418.xyz));
        vec2 _1511 = vec2(dot(_1199, _1412.xyz), dot(_1199, _1418.xyz));
        float _1521 = 1.0;
        float _1522 = 1.0;
        vec3 _1523 = vec3(0.5, 0.5, 1.0);
        vec3 _1525 = vec3(0.0, 0.0, 1.0);
        uint _1526 = _1253._m7;
        uint _1530 = _1253._m9;
        vec4 _1529 = _77(_1530);
        uvec2 _1535 = _1253._m5;
        vec4 _1534 = _90(_1535);
        vec2 _1539 = _1501 * _1534.xy;
        vec2 _1544 = _1511 * _1534.xy;
        vec2 _1559 = (_1428.xy * _1534.xy) + _1534.zw;
        vec2 _1560 = _1539;
        vec2 _1562 = _1544;
        vec4 _1549 = _102(_1550, _1559, _1560, _1562);
        vec2 _1565 = (_1549.xy * 2.0) - vec2(1.0);
        float _1575 = 1.0 - dot(_1565, _1565);
        _1523 = vec3(_1565, sqrt(_10(_1575)));
        _1525 = _1523;
        _1521 = _1549.z;
        float _1584 = _1549.w;
        _1522 = _52(_1584);
        bool _1591 = _1522 <= (4.0 * _1439);
        bool _1598;
        if (_1591)
        {
            _1598 = _1529.w <= _1439;
        }
        else
        {
            _1598 = _1591;
        }
        if (_1598)
        {
            continue;
        }
        _1523 = _1525;
        if ((_1473 & 128u) != 0u)
        {
            _1607 = vec3(-_1523.x, -_1523.y, _1523.z);
        }
        else
        {
            _1607 = _1523;
        }
        _1523 = _1607;
        uint _1622 = _1253._m8;
        uint _1626 = _1622;
        float _1625 = 1.0 + (_80(_1626).w * 0.062745101749897003173828125);
        uint _1634 = _1526;
        float _1633 = _77(_1634).z;
        uint _1639 = _1622;
        vec3 _1638 = _77(_1639).xyz;
        float _1652 = _1625 - (_1625 * abs((_1428.z * 2.0) - 1.0));
        _1522 *= _10(_1652);
        float _1656 = _1522;
        if ((_1526 & 1u) != 0u)
        {
            vec3 _1663 = _1638;
            _1638 = vec3(0.0);
            uvec2 _1666 = _1253._m3;
            vec4 _1665 = _90(_1666);
            vec2 _1670 = _1501 * _1665.xy;
            vec2 _1675 = _1511 * _1665.xy;
            vec2 _1689 = (_1428.xy * _1665.xy) + _1665.zw;
            vec2 _1690 = _1670;
            vec2 _1692 = _1675;
            vec4 _1680 = _102(_1550, _1689, _1690, _1692);
            vec4 _1695 = _1680;
            _1680 = _58(_1695);
            _1638 = _1680.xyz;
            float _1707 = (_1680.w - _1439) / (1.0 - _1439);
            _1656 = _10(_1707);
            _1638 *= _1663;
        }
        vec3 _1712 = normalize(vec3(_665._m17[0].z, _665._m17[1].z, _665._m17[2].z));
        float _1721 = dot(_1712, normalize(_1415.xyz));
        float _1727 = _1721;
        vec2 _1732 = _1523.xy * _69(_1727);
        _1523 = vec3(_1732.x, _1732.y, _1523.z);
        if ((_1473 & 16384u) != 0u)
        {
            float _1745 = abs(_1721);
            _1740 = _10(_1745);
        }
        else
        {
            float _1748 = _1721;
            _1740 = _10(_1748);
        }
        float _1735 = _1740;
        float _1752 = ((_1735 * _1656) * _1529.w) * _1633;
        _665._m10 += (_1529.xyz * (_1752 * 64.0));
        uint _1771 = _1253._m10;
        uint _1775 = _1771;
        vec4 _1774 = _77(_1775);
        if ((_1526 & 2u) != 0u)
        {
            uvec2 _1784 = _1253._m4;
            vec4 _1783 = _90(_1784);
            vec2 _1788 = _1501 * _1783.xy;
            vec2 _1793 = _1511 * _1783.xy;
            vec2 _1806 = (_1428.xy * _1783.xy) + _1783.zw;
            vec2 _1807 = _1788;
            vec2 _1809 = _1793;
            _1774 = _102(_1550, _1806, _1807, _1809);
            _1774 *= _1774;
        }
        if ((_1526 & 32u) != 0u)
        {
            uint _1822 = _1526;
            float _1821 = _77(_1822).x;
            uint _1827 = _1526;
            float _1826 = _80(_1827).y;
            float _1833 = _1821;
            float _1831 = mix(_1826, 0.0, _10(_1833));
            float _1842 = _1521 - (_1831 / 255.0);
            float _1837 = float(_10(_1842) > 0.0);
            _1522 *= _1837;
        }
        float _1849 = _1522 * _1735;
        uint _1853 = _1253._m6;
        uint _1857 = _1853;
        vec4 _1862 = _77(_1857) * _1849;
        vec4 _1856 = _22(_1862);
        _665._m11 = max(_665._m11, _1856.x);
        _665._m0 = mix(_665._m0, _1638, _1856.xxx);
        _665._m2 = mix(_665._m2, _1774.xyz, _1856.yyy);
        vec3 _1885 = _1712;
        vec3 _1895 = _1412.xyz + (_1885 * dot(_1412.xyz, _1885));
        _1412 = vec4(_1895.x, _1895.y, _1895.z, _1412.w);
        vec3 _1906 = _1418.xyz + (_1885 * dot(_1418.xyz, _1885));
        _1418 = vec4(_1906.x, _1906.y, _1906.z, _1418.w);
        _1523 = ((normalize(_1412.xyz) * _1523.x) + (normalize(_1418.xyz) * _1523.y)) + (_1885 * _1523.z);
        if ((_1473 & 256u) != 0u)
        {
            vec3 _1933 = mix(_1712, _1523, _1856.www);
            float _1939 = dot(_1933, _1712);
            _1523 = (_665._m6 * _1939) + ((_1933 - (_1712 * _1939)) * dot(_665._m6, _1712));
        }
        else
        {
            if ((_1473 & 64u) != 0u)
            {
                _1523 = mix(mix(_665._m6, _1712, vec3(_1849)), _1523, _1856.www);
            }
            else
            {
                _1523 = mix(_665._m6, _1523, _1856.www);
            }
        }
        _665._m6 = normalize(_1523);
        _665._m3 = mix(_665._m3, _1774.w, _1856.z);
    }
    vec3 _1993 = vec3(0.0);
    vec3 _1994 = vec3(_665._m34.x, _665._m34.y, _665._m34.z);
    vec3 _2002 = vec3(_665._m34.w, _665._m35.x, _665._m35.y);
    vec3 _2010 = vec3(_665._m35.z, _665._m35.w, _665._m36.x);
    vec3 _2018 = vec3(_665._m36.y, _665._m36.z, _665._m36.w);
    vec3 _2026 = ((_1994 - (_2002 * _665._m6.y)) + (_2010 * _665._m6.z)) - (_2018 * _665._m6.x);
    float _2049 = _975._m11.x * _686._m9.x;
    _1993 += max(_2026 * _10(_2049), vec3(0.0));
    float _2059;
    if (dot(_665._m10, vec3(1.0)) > 0.0)
    {
        _2059 = -_665._m3;
    }
    else
    {
        _2059 = _665._m3;
    }
    _665._m3 = _2059;
    _665._m18 = _1993;
    _665._m19 = _1993;
    uint _2076 = _1128;
    _2105 _2107;
    vec3 _2404;
    float _2493;
    float _2511;
    _2880 _2882;
    uint _3003;
    _2880 _3026;
    while (_2076 < _1129)
    {
        uint _2086 = _1228._m0[_2076];
        uint _2090 = _2086 & 4095u;
        uint _2093 = _2090;
        if (_2093 >= _2090)
        {
            _2076++;
        }
        int _2102 = 4;
        int _2103 = 4;
        int _2104 = 3;
        _2107._m0 = _2111._m0[(uint(_2102) * _2093) + 0u].xyz;
        float _2126 = _2111._m0[(uint(_2102) * _2093) + 0u].w;
        _2107._m1 = _27(_2126);
        _2107._m2 = _2111._m0[(uint(_2102) * _2093) + 1u];
        _2107._m3 = _2111._m0[(uint(_2102) * _2093) + 2u];
        _2107._m4 = _2150._m0[(uint(_2103) * _2093) + 0u];
        _2107._m5 = _2150._m0[(uint(_2103) * _2093) + 1u];
        _2107._m6 = _2150._m0[(uint(_2103) * _2093) + 2u];
        float _2180 = _2111._m0[(uint(_2102) * _2093) + 3u].x;
        _2107._m7.x = _27(_2180);
        float _2190 = _2111._m0[(uint(_2102) * _2093) + 3u].y;
        _2107._m7.y = _27(_2190);
        float _2200 = _2111._m0[(uint(_2102) * _2093) + 3u].z;
        _2107._m7.z = _27(_2200);
        float _2210 = _2111._m0[(uint(_2102) * _2093) + 3u].w;
        _2107._m7.w = _27(_2210);
        _2107._m8 = _2219._m0[(uint(_2104) * _2093) + 0u];
        _2107._m9 = _2219._m0[(uint(_2104) * _2093) + 1u];
        _2107._m10 = _2219._m0[(uint(_2104) * _2093) + 2u];
        float _2249 = _2150._m0[(uint(_2103) * _2093) + 3u].x;
        _2107._m11 = _27(_2249);
        float _2259 = _2150._m0[(uint(_2103) * _2093) + 3u].y;
        _2107._m12 = _27(_2259);
        _2107._m13 = _2150._m0[(uint(_2103) * _2093) + 3u].z;
        float _2277 = _2150._m0[(uint(_2103) * _2093) + 3u].w;
        _2107._m14 = _27(_2277);
        float _2282 = 0.0039215688593685626983642578125;
        vec4 _2283 = vec4(_665._m14, 1.0);
        float _2290 = 1.0 / dot(_2283, _2107._m6);
        vec3 _2296 = vec3(dot(_2283, _2107._m4) * _2290, dot(_2283, _2107._m5) * _2290, dot(_2283, _2107._m3));
        uint _2314 = _2107._m1;
        uint _2317 = _1033;
        _2317 |= 64u;
        float _2321 = _2296.x;
        float _2324 = _2296.y;
        float _2327 = _2296.z;
        bool _2332 = _43(_2321, _2324, _2327) <= _2282;
        bool _2349;
        if (!_2332)
        {
            float _2336 = _2296.x;
            float _2339 = _2296.y;
            float _2342 = _2296.z;
            _2349 = _38(_2336, _2339, _2342) >= (1.0 - _2282);
        }
        else
        {
            _2349 = _2332;
        }
        bool _2357;
        if (!_2349)
        {
            _2357 = (_2314 & _2317) != 0u;
        }
        else
        {
            _2357 = _2349;
        }
        if (_2357)
        {
            continue;
        }
        if ((_2314 & 3u) == 2u)
        {
            vec2 _2376 = fract((_2296.xy * _686._m10.xy) + _686._m10.zw);
            _2296 = vec3(_2376.x, _2376.y, _2296.z);
        }
        vec3 _2379 = _2107._m0;
        float _2382 = 1.0;
        float _2383 = 1.0;
        vec3 _2384 = vec3(0.0, 0.0, 1.0);
        vec3 _2385 = vec3(0.0, 0.0, 1.0);
        uint _2386 = _2107._m1;
        vec3 _2389 = (_2296 * 2.0) - vec3(1.0);
        vec2 _2394 = _2296.xy;
        vec3 _2397 = _2107._m10.xyz;
        if ((_2386 & 3u) == 2u)
        {
            _2404 = _2397;
        }
        else
        {
            _2404 = normalize(_2379 - _665._m14);
        }
        _2384 = _2404;
        _2384 = _2384;
        float _2421 = dot(_665._m6, _2384);
        float _2416 = _10(_2421);
        bool _2425 = _2416 <= _2282;
        bool _2432;
        if (_2425)
        {
            _2432 = (_2386 & 48u) == 0u;
        }
        else
        {
            _2432 = _2425;
        }
        if (_2432)
        {
            continue;
        }
        uvec2 _2437 = _2107._m7.zw;
        vec4 _2436 = _90(_2437);
        float _2442 = TEXTURE_LOD(_2443, vec4((_2394 * _2436.xy) + _2436.zw, 0.0, 0.0).xy, vec4((_2394 * _2436.xy) + _2436.zw, 0.0, 0.0).w).x;
        float _2469 = _2442 * _2442;
        uint _2473 = _2386 & 3u;
        bool _2478 = _2473 == 1u;
        bool _2490;
        if (!_2478)
        {
            bool _2483 = _2473 == 0u;
            bool _2489;
            if (_2483)
            {
                _2489 = _2107._m8.z != 0.0;
            }
            else
            {
                _2489 = _2483;
            }
            _2490 = _2489;
        }
        else
        {
            _2490 = _2478;
        }
        bool _2476 = _2490;
        if (_2476)
        {
            float _2496 = _2107._m8.w;
            _2493 = _10(_2496);
        }
        else
        {
            _2493 = 0.5;
        }
        float _2491 = _2493;
        bool _2504 = _2473 == 0u;
        bool _2510;
        if (_2504)
        {
            _2510 = _2107._m8.z != 0.0;
        }
        else
        {
            _2510 = _2504;
        }
        if (_2510)
        {
            float _2519 = sqrt(dot(_2389, _2389));
            _2511 = min(0.9921875, _10(_2519));
        }
        else
        {
            _2511 = _2296.z;
        }
        float _2502 = _2511;
        uvec2 _2527 = _2107._m7.xy;
        vec4 _2526 = _90(_2527);
        vec2 _2532 = vec2(_2502, _2491);
        float _2536 = TEXTURE_LOD(_2443, vec4((_2532 * _2526.xy) + _2526.zw, 0.0, 0.0).xy, vec4((_2532 * _2526.xy) + _2526.zw, 0.0, 0.0).w).x;
        _2536 *= _2536;
        _2382 = _2536 * _2469;
        if ((_2386 & 48u) != 0u)
        {
            vec4 _2573 = _2107._m10;
            vec4 _2576 = _2107._m8;
            vec4 _2579 = _2107._m9;
            float _2582 = dot(_665._m14, _2573.xyz) + _2573.w;
            if (_2582 < 0.0)
            {
                continue;
            }
            float _2596 = length(_2573.xyz);
            float _2603 = _2582 * 50.0;
            float _2600 = _10(_2603);
            _2382 *= (_2600 * _2600);
            _2582 /= _2596;
            _2573 /= vec4(_2596);
            vec3 _2617 = reflect(-_665._m13, _665._m6);
            if (dot(_2617, _2573.xyz) > 0.0)
            {
                _2617 = reflect(_2617, _2573.xyz);
            }
            float _2635 = dot(_2617, _2573.xyz);
            float _2640 = _2582 / _2635;
            vec3 _2644 = _665._m14 - (_2617 * _2640);
            vec3 _2651 = _2644 - _2379;
            float _2655 = dot(_2651, _2576.xyz) / _2576.w;
            float _2663 = dot(_2651, _2579.xyz) / _2579.w;
            if ((_2386 & 48u) == 32u)
            {
                vec2 _2676 = vec2(_2655, _2663);
                float _2680 = 1.0 / max(1.0, length(vec2(_2655, _2663)));
                _2655 *= (_2680 * _2576.w);
                _2663 *= (_2680 * _2579.w);
            }
            else
            {
                float _2702 = abs(_2655);
                float _2704 = _2655;
                _2655 = (_10(_2702) * _69(_2704)) * _2576.w;
                float _2713 = abs(_2663);
                float _2715 = _2663;
                _2663 = (_10(_2713) * _69(_2715)) * _2579.w;
            }
            vec3 _2722 = (_2576.xyz * _2655) + (_2579.xyz * _2663);
            _2379 += _2722;
            _2384 = normalize(_2379 - _665._m14);
            _2384 = _2384;
        }
        else
        {
            uint _2742 = (_2107._m14 >> uint(16)) & 255u;
            if (_2742 == 0u)
            {
                vec4 _2751 = _2107._m9;
                if (dot(_2751.xyz, _665._m14) < (_2751.w - _2282))
                {
                    continue;
                }
            }
            else
            {
                if (_2742 == 1u)
                {
                    vec3 _2772 = _2107._m9.xyz;
                    float _2777 = _2107._m9.w;
                    uint _2781 = _27(_2777);
                    vec3 _2776 = (((_84(_2781) * 2.0) - vec3(1.0)) * _2772) + _2379;
                    vec3 _2790 = abs((_665._m14 - _2776) / _2772);
                    float _2798 = _2790.x;
                    float _2801 = _2790.y;
                    float _2804 = _2790.z;
                    if (_38(_2798, _2801, _2804) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2382 <= (_2282 / 256.0))
        {
            continue;
        }
        float _2820 = 1.0;
        if ((_2314 & 4u) != 0u)
        {
            float _2827 = float(_2107._m14 & 255u) / 255.0;
            float _2833 = 0.00999999977648258209228515625;
            vec3 _2835 = _665._m14 + (_665._m6 * _2833);
            uint _2843 = 0u;
            if ((_2314 & 3u) == 0u)
            {
                vec3 _2849 = _2835 - _2107._m2.xyz;
                float _2855 = _2849.x;
                float _2858 = _2849.y;
                float _2861 = _2849.z;
                _2843 = _49(_2855, _2858, _2861);
            }
            else
            {
                if ((_2314 & 3u) == 2u)
                {
                    float _2871 = 0.0;
                    for (; _2843 < 3u; _2843++)
                    {
                        int _2879 = 5;
                        _2882._m0 = _2886._m0[(uint(_2879) * ((_2314 >> uint(22)) + _2843)) + 0u];
                        _2882._m1 = _2886._m0[(uint(_2879) * ((_2314 >> uint(22)) + _2843)) + 1u];
                        _2882._m2 = _2886._m0[(uint(_2879) * ((_2314 >> uint(22)) + _2843)) + 2u];
                        _2882._m3 = _2886._m0[(uint(_2879) * ((_2314 >> uint(22)) + _2843)) + 3u];
                        _2882._m4 = _2886._m0[(uint(_2879) * ((_2314 >> uint(22)) + _2843)) + 4u];
                        vec2 _2943 = vec2(dot(_2835, _2882._m0.xyz) + _2882._m0.w, dot(_2835, _2882._m1.xyz) + _2882._m1.w);
                        _2943 = abs((_2943 * 2.0) - vec2(1.0));
                        bool _2968 = _2943.x < 1.0;
                        bool _2974;
                        if (_2968)
                        {
                            _2974 = _2943.y < 1.0;
                        }
                        else
                        {
                            _2974 = _2968;
                        }
                        if (_2974)
                        {
                            _2871 = (1.0 - max(_2943.x, _2943.y)) * _686._m11.w;
                            break;
                        }
                    }
                    _2843 = min(2u, _2843);
                    uint _2991 = uint(_665._m16.x) ^ (uint(_665._m16.y) << uint(1));
                    if (_686._m12.w > 0.0)
                    {
                        _3003 = uint(_686._m13.x);
                    }
                    else
                    {
                        _3003 = 0u;
                    }
                    _2991 ^= _3003;
                    _2843 += uint(int(((float(_2991 & 3u) * 0.25) + 0.125) > _2871));
                }
            }
            int _3025 = 5;
            _3026._m0 = _2886._m0[(uint(_3025) * ((_2314 >> uint(22)) + _2843)) + 0u];
            _3026._m1 = _2886._m0[(uint(_3025) * ((_2314 >> uint(22)) + _2843)) + 1u];
            _3026._m2 = _2886._m0[(uint(_3025) * ((_2314 >> uint(22)) + _2843)) + 2u];
            _3026._m3 = _2886._m0[(uint(_3025) * ((_2314 >> uint(22)) + _2843)) + 3u];
            _3026._m4 = _2886._m0[(uint(_3025) * ((_2314 >> uint(22)) + _2843)) + 4u];
            vec4 _3082 = vec4((_2835.x * _3026._m0.x) + ((_2835.y * _3026._m0.y) + ((_2835.z * _3026._m0.z) + _3026._m0.w)), (_2835.x * _3026._m1.x) + ((_2835.y * _3026._m1.y) + ((_2835.z * _3026._m1.z) + _3026._m1.w)), (_2835.x * _3026._m2.x) + ((_2835.y * _3026._m2.y) + ((_2835.z * _3026._m2.z) + _3026._m2.w)), (_2835.x * _3026._m3.x) + ((_2835.y * _3026._m3.y) + ((_2835.z * _3026._m3.z) + _3026._m3.w)));
            vec3 _3169 = _3082.xyz / vec3(_3082.w);
            _3082 = vec4(_3169.x, _3169.y, _3169.z, _3082.w);
            bool _3177 = min(_3082.x, _3082.y) > 0.0;
            bool _3186;
            if (_3177)
            {
                _3186 = max(_3082.x, _3082.y) < 1.0;
            }
            else
            {
                _3186 = _3177;
            }
            if (_3186)
            {
                vec2 _3198 = (_3082.xy * _3026._m4.xy) + _3026._m4.zw;
                _3082 = vec4(_3198.x, _3198.y, _3082.z, _3082.w);
                if (false)
                {
                    _2820 = textureLod(_3206, vec3(_3082.xyz.xy, _3082.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3213 = (_3082.xy * _686._m14.xy) + vec2(0.5);
                    vec2 _3222 = floor(_3213);
                    vec2 _3225 = _3213 - _3222;
                    _3222 -= vec2(0.5);
                    vec2 _3232 = vec2(4.0) - (_3225 * 3.0);
                    vec2 _3238 = vec2(7.0);
                    vec2 _3241 = vec2(1.0) + (_3225 * 3.0);
                    vec2 _3246 = (_3222 + (((vec2(3.0) - (_3225 * 2.0)) / _3232) - vec2(2.0))) * _686._m14.zw;
                    vec2 _3261 = (_3222 + ((vec2(3.0) + _3225) / _3238)) * _686._m14.zw;
                    vec2 _3273 = (_3222 + ((_3225 / _3241) + vec2(2.0))) * _686._m14.zw;
                    vec3 _3297 = vec3(_3246.x, _3246.y, _3082.z);
                    _2820 = (_3232.x * _3232.y) * textureLod(_3206, vec3(_3297.xy, _3297.z), 0.0);
                    vec3 _3313 = vec3(_3261.x, _3246.y, _3082.z);
                    _2820 += ((_3238.x * _3232.y) * textureLod(_3206, vec3(_3313.xy, _3313.z), 0.0));
                    vec3 _3331 = vec3(_3273.x, _3246.y, _3082.z);
                    _2820 += ((_3241.x * _3232.y) * textureLod(_3206, vec3(_3331.xy, _3331.z), 0.0));
                    vec3 _3349 = vec3(_3246.x, _3261.y, _3082.z);
                    _2820 += ((_3232.x * _3238.y) * textureLod(_3206, vec3(_3349.xy, _3349.z), 0.0));
                    vec3 _3367 = vec3(_3261.x, _3261.y, _3082.z);
                    _2820 += ((_3238.x * _3238.y) * textureLod(_3206, vec3(_3367.xy, _3367.z), 0.0));
                    vec3 _3385 = vec3(_3273.x, _3261.y, _3082.z);
                    _2820 += ((_3241.x * _3238.y) * textureLod(_3206, vec3(_3385.xy, _3385.z), 0.0));
                    vec3 _3403 = vec3(_3246.x, _3273.y, _3082.z);
                    _2820 += ((_3232.x * _3241.y) * textureLod(_3206, vec3(_3403.xy, _3403.z), 0.0));
                    vec3 _3421 = vec3(_3261.x, _3273.y, _3082.z);
                    _2820 += ((_3238.x * _3241.y) * textureLod(_3206, vec3(_3421.xy, _3421.z), 0.0));
                    vec3 _3439 = vec3(_3273.x, _3273.y, _3082.z);
                    _2820 += ((_3241.x * _3241.y) * textureLod(_3206, vec3(_3439.xy, _3439.z), 0.0));
                    _2820 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _2820 = float((_2314 & 3u) == 2u);
            }
            float _3453 = float((_2314 >> uint(16)) & 63u) / 63.0;
            float _3467 = ((_2820 * _3453) + 1.0) - _3453;
            _2820 = _10(_3467);
        }
        uint _3470 = _2107._m12;
        vec3 _3469 = (_105(_3470) * _2820) * _2382;
        _2383 *= _2107._m13;
        vec3 _3482 = _3469;
        vec3 _3484 = _2384;
        float _3491 = dot(_665._m6, _3484);
        float _3486 = _10(_3491);
        vec3 _3497 = _665._m6;
        vec3 _3500 = _665._m13;
        vec3 _3503 = _2384;
        vec3 _3505 = _665._m2;
        float _3508 = abs(_665._m3);
        vec3 _3493 = _118(_3497, _3500, _3503, _3505, _3508);
        _665._m20 += (((_3493 * _2383) * _3482) * _3486);
        vec3 _3522 = mix(_3482, vec3(0.0), bvec3((_2314 & 256u) > 0u));
        _665._m19 += (_3522 * _3486);
    }
    _665._m19 = _665._m19;
    _665._m20 += _665._m10;
    float _3546 = 0.064999997615814208984375;
    float _3548 = 1.0 + _3546;
    bool _3551 = false;
    uint _3556;
    if (_686._m15.w > 0.00999999977648258209228515625)
    {
        _3556 = uint(_686._m15.x);
    }
    else
    {
        _3556 = 0u;
    }
    uint _3552 = _3556;
    _3574 _3576;
    for (uint _3564 = 0u; _3564 < _3552; _3564++)
    {
        int _3573 = 4;
        _3576._m0 = _3580._m0[(uint(_3573) * _3564) + 0u];
        _3576._m1 = _3580._m0[(uint(_3573) * _3564) + 1u];
        _3576._m2 = _3580._m0[(uint(_3573) * _3564) + 2u];
        float _3610 = _3580._m0[(uint(_3573) * _3564) + 3u].x;
        _3576._m3 = _27(_3610);
        float _3620 = _3580._m0[(uint(_3573) * _3564) + 3u].y;
        _3576._m4 = _27(_3620);
        float _3630 = _3580._m0[(uint(_3573) * _3564) + 3u].z;
        _3576._m5 = _27(_3630);
        vec4 _3635 = vec4(_665._m14, 1.0);
        vec3 _3642 = vec3(dot(_3635, _3576._m1), dot(_3635, _3576._m2), dot(_3635, _3576._m0));
        float _3656 = _3642.x;
        float _3659 = _3642.y;
        float _3662 = _3642.z;
        bool _3666 = _43(_3656, _3659, _3662) >= 0.0;
        bool _3675;
        if (_3666)
        {
            _3675 = max(_3642.x, _3642.y) < 1.0;
        }
        else
        {
            _3675 = _3666;
        }
        bool _3682;
        if (_3675)
        {
            _3682 = _3642.z < _3548;
        }
        else
        {
            _3682 = _3675;
        }
        if (_3682)
        {
            float _3685 = _3642.z;
            vec4 _3688 = vec4(_665._m14, 1.0);
            vec2 _3695 = vec2(0.0);
            _3695 = (((_3688.xy - _686._m16.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _3708 = 0.000244140625;
            float _3714 = abs(_665._m6.z) * 2.0;
            _3708 *= _10(_3714);
            vec3 _3718 = vec3(TEXTURE_LOD(_3719, vec4(_3695 + vec2(_3708), 0.0, 0.0).xy, vec4(_3695 + vec2(_3708), 0.0, 0.0).w).x, TEXTURE_LOD(_3719, vec4(_3695, 0.0, 0.0).xy, vec4(_3695, 0.0, 0.0).w).x, TEXTURE_LOD(_3719, vec4(_3695 - vec2(_3708), 0.0, 0.0).xy, vec4(_3695 - vec2(_3708), 0.0, 0.0).w).x);
            float _3782 = 2.0 - (2.0 * (length(_3688.xy - _686._m16.zw) / 16.0));
            _3718 *= _10(_3782);
            float _3789 = 1.0 - _3685;
            float _3786 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_3789));
            float _3800 = (_665._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _3792 = (_3718 * _3786) * _10(_3800);
            float _3809 = _3548 - _3685;
            float _3803 = (1.0 - _3786) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_3809));
            float _3824 = ((-_665._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _3813 = (_3718 * _3803) * _10(_3824);
            _3718 = _3792 + _3813;
            float _3835 = 1.02499997615814208984375 - _3685;
            float _3830 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_3835));
            float _3838 = _686._m15.w;
            _665._m19 = mix(_665._m19, (_665._m19 * _3718) + (_665._m19 * mix(1.0, 0.5, _3830)), vec3(_3838));
            break;
        }
    }
    _665._m19 *= _665._m0;
    _665._m21 = _665._m19 + _665._m20;
    vec3 _3872 = vec3(0.0);
    if (_975._m12.w > 0.0)
    {
        vec4 _3878 = vec4(0.0030000000260770320892333984375, 0.00999999977648258209228515625, 0.0500000007450580596923828125, 0.300000011920928955078125);
        vec2 _3883 = abs(vec2(1.0) / _686._m6.zw);
        vec2 _3889 = ((gl_FragCoord.xy * 1.5) * _686._m6.zw) * (_3883 / vec2(32.0));
        vec4 _3903 = TEXTURE_LOD(_3904, vec4((_3889 * _3878.xy) + (vec2(_686._m1.x * 0.75) * _3878.zw), 0.0, 0.0).xy, vec4((_3889 * _3878.xy) + (vec2(_686._m1.x * 0.75) * _3878.zw), 0.0, 0.0).w);
        float _3947 = (length(_691.xyz) - 10.0) * 2.0;
        float _3940 = 1.0 - _10(_3947);
        float _3950 = 1.0 - dot(_665._m6, normalize(-_691.xyz));
        float _3959 = 2.0;
        _3959 *= ((sin((_686._m1.x * 5.0) * 0.75) * 0.5) + 0.699999988079071044921875);
        _3959 *= _3959;
        _3959 *= _3950;
        _3950 *= _3950;
        float _3979 = (_3950 * _3950) * 9.9999997473787516355514526367188e-05;
        vec3 _3989 = _3903.xyz * _3903.xyz;
        _3903 = vec4(_3989.x, _3989.y, _3989.z, _3903.w);
        vec3 _3992 = _3903.xyz;
        float _4002 = (_3992.x * _3950) + _3979;
        vec3 _3995 = _975._m12.xyz * _10(_4002);
        float _4009 = _3992.x;
        vec3 _4008 = _975._m12.xyz * _10(_4009);
        vec3 _4017 = mix(_3995, _4008, vec3(0.0500000007450580596923828125));
        float _4027 = (0.5 * _3950) + _3979;
        vec3 _4022 = _975._m12.xyz * _10(_4027);
        _4017 /= _686._m17.xyz;
        vec3 _4038 = (_4017 * _975._m12.w) * 0.5;
        _3872 += (_4038 * _3940);
    }
    _665._m19 += _3872;
    vec3 _4060 = _665._m19 + _665._m20;
    _4055 = vec4(_4060.x, _4060.y, _4060.z, _4055.w);
    vec3 _4064 = _665._m6;
    bool _4067 = false;
    vec2 _4068 = _148(_4064, _4067);
    _4063 = vec4(_4068.x, _4068.y, _4063.z, _4063.w);
    float _4072 = _665._m2.x;
    float _4076 = _665._m2.y;
    float _4080 = _665._m2.z;
    float _4084 = _665._m3;
    _4071 = vec4(_72(_4072), _72(_4076), _72(_4080), _151(_4084));
    vec3 _4094 = _4055.xyz + _975._m13.xyz;
    _4055 = vec4(_4094.x, _4094.y, _4094.z, _4055.w);
}


