
// SKY FLARES
#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

layout(set = 2, binding = 0, std140) uniform _180_182
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _182;

layout(set = 0, binding = 0, std140) uniform _203_205
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
    vec4 _m30;
    vec4 _m31;
    vec4 _m32;
    vec4 _m33;
} _205;

layout(set = 0, binding = 1, std430) restrict readonly buffer _935_937
{
    vec4 _m0[];
} _937;

layout(push_constant, std430) uniform _931_933
{
    int _m0;
    int _m1;
} _933;

layout(set = 2, binding = 1) uniform SAMPLER_2D _248;
layout(set = 0, binding = 2) uniform sampler3D _693;
layout(set = 0, binding = 3) uniform sampler3D _714;
layout(set = 0, binding = 4) uniform sampler3D _836;
layout(set = 0, binding = 5) uniform SAMPLER_2D _901;

layout(location = 2) in vec4 _250;
layout(location = 7) in vec4 _277;
layout(location = 8) in vec4 _286;
layout(location = 3) in vec4 _467;
layout(location = 4) in vec4 _508;
layout(location = 5) in vec4 _563;
layout(location = 6) in vec4 _567;
layout(location = 0) out vec4 _583;
layout(location = 1) out vec4 _883;
layout(location = 2) out vec4 _884;

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

uint _15(float _14)
{
    return floatBitsToUint(_14);
}

float _40(float _36, vec4 _37, float _38, bool _39)
{
    float _154 = _37.w / (_36 + _37.z);
    return _154 * _38;
}

float _18(float _17)
{
    float _52 = (((-0.15658299624919891357421875) * abs(_17)) + 1.57079637050628662109375) * sqrt(1.0 - abs(_17));
    float _64;
    if (_17 >= 0.0)
    {
        _64 = _52;
    }
    else
    {
        _64 = 3.1415927410125732421875 - _52;
    }
    return _64;
}

float _21(float _20)
{
    float _78;
    if (_20 < 1.0)
    {
        _78 = _20;
    }
    else
    {
        _78 = 1.0 / _20;
    }
    float _77 = _78;
    float _88 = _77 * _77;
    float _92 = 0.087292902171611785888671875;
    _92 = (-0.3018949925899505615234375) + (_92 * _88);
    _92 = 1.0 + (_92 * _88);
    _92 *= _77;
    float _106;
    if (_20 < 1.0)
    {
        _106 = _92;
    }
    else
    {
        _106 = 1.57079637050628662109375 - _92;
    }
    return _106;
}

float _24(float _23)
{
    float _121 = abs(_23);
    float _118 = _21(_121);
    float _123;
    if (_23 < 0.0)
    {
        _123 = -_118;
    }
    else
    {
        _123 = _118;
    }
    return _123;
}

float _29(float _27, float _28)
{
    float _139 = _27 / _28;
    float _135 = _24(_139);
    if (_28 < 0.0)
    {
        _135 += ((_27 >= 0.0) ? 3.1415927410125732421875 : (-3.1415927410125732421875));
    }
    return _135;
}

void main()
{
    int _171 = 6;
    float _173 = 1.0 / float(_171);
    float _177 = 100.0;
    float _179 = _182._m2.x * _177;
    float _190 = 1.0;
    vec2 _193 = fract(gl_FragCoord.xy * 0.5);
    int _202;
    if (dot(_205._m20.zw, vec2(1.0)) > 0.0)
    {
        _202 = int(_205._m21.x) & 3;
    }
    else
    {
        _202 = 0;
    }
    int _201 = _202;
    float _225 = fract(((_193.x * 0.5) + _193.y) + (float(_201) * 0.125));
    float _239 = 0.100000001490116119384765625 * _182._m3.w;
    vec4 _244 = SAMPLE_TEXTURE(_248, (_250.xy * _182._m4.xy) + (_182._m4.zw * _205._m22.xx));
    if (_244.w < 0.0039215688593685626983642578125)
    {
        _244.w = 0.0;
    }
    else
    {
        vec2 _276 = normalize(_277.xyz).xy * _239;
        vec2 _285 = normalize(_286.xyz).xy * _239;
        if (_286.z < 0.0)
        {
            _285 *= (-1.0);
        }
        float _302 = 1.0;
        for (int _303 = 0; _303 < _171; _303++)
        {
            float _312 = _173 * (float(_303) + _225);
            vec2 _319 = _250.xy + (_276 * (1.0 - _312));
            vec4 _327 = SAMPLE_TEXTURE(_248, (clamp(_319, vec2(0.0), vec2(1.0)) * _182._m4.xy) + (_182._m4.zw * _205._m22.xx));
            float _345 = max(0.001000000047497451305389404296875, _327.x - _312);
            _302 *= exp(((-_345) * _179) * _173);
            float _361 = 1.0;
            for (int _362 = 0; _362 < _171; _362++)
            {
                float _371 = _173 * float(_362);
                vec4 _376 = SAMPLE_TEXTURE(_248, (clamp(_319 - (_285 * (1.0 - _371)), vec2(0.0), vec2(1.0)) * _182._m4.xy) + (_182._m4.zw * _205._m22.xx));
                float _398 = max(0.001000000047497451305389404296875, (_376.x - _371) - _312);
                _361 *= exp(((-_398) * _179) * _173);
            }
            float _428 = (_286.z * _182._m5.z) + 0.5;
            _361 = mix(_361, 1.0 - _361, _10(_428));
            _190 = mix(_190, _361, _345);
        }
        _244.w *= (1.0 - _302);
    }
    _244.w *= SAMPLE_TEXTURE(_248, (_250.xy * _182._m6.xy) + _182._m6.zw).z;
    float _460 = 1.0;
    float _461 = 0.0;
    _190 *= _460;
    vec3 _466 = normalize(_467.xyz);
    float _471 = _205._m5.x * 1.57079637050628662109375;
    float _475 = _205._m6.x * 3.1415927410125732421875;
    vec3 _479 = vec3(sin(_471) * cos(_475), sin(_471) * sin(_475), cos(_471));
    float _493 = dot(normalize(_479), _466);
    float _498 = max((_493 * 0.5) + 0.5, (_493 * (-0.5)) + 0.5);
    vec3 _507 = normalize(_508.xyz);
    float _512 = 0.079577468335628509521484375;
    vec2 _514 = vec2(_182._m7.x, -_182._m8.x);
    float _523 = dot(_507, _479);
    vec2 _527 = _514 * _514;
    vec2 _531 = vec2(1.0) - _527;
    vec2 _534 = (vec2(1.0) + _527) - ((vec2(2.0) * _514) * _523);
    vec2 _544 = (_531 * _512) / (_534 * sqrt(_534));
    float _553 = mix(_544.y, _544.x, (_523 * 0.5) + 0.5);
    vec3 _562 = _563.xyz;
    vec3 _566 = _567.xyz * _190;
    float _572 = (1.0 - _244.y) * (_182._m9.w * 10.0);
    vec3 _603 = (_562 * _182._m10.xyz) + (_566 * ((vec3(_498) + (_182._m9.xyz * _572)) + vec3(_553)));
    _583 = vec4(_603.x, _603.y, _603.z, _583.w);
    float _612 = (_244.w * _460) - _461;
    _583.w = _10(_612);
    vec2 _616 = gl_FragCoord.xy * _205._m23.zw;
      // FIX for SKY
    _616.x -= vk3d_params[VIEW].stereo.x*0.5;
    float _624 = gl_FragCoord.z;
    vec4 _627 = vec4(0.0);
    float _629 = 1.0;
    float _633 = _205._m24.w;
    uint _631 = _15(_633);
    if ((_631 & 6u) != 0u)
    {
        vec2 _643 = _616 + vec2(0.0);
        vec3 _646 = _205._m25.xyz;
        float _651 = 0.100000001490116119384765625;
        float _652 = _205._m26.y;
        float _656 = _205._m25.z;
        float _659 = 0.0;
        float _662 = _624;
        vec4 _664 = _205._m7;
        float _667 = 1.0;
        bool _668 = false;
        float _660 = _40(_662, _664, _667, _668);
        _659 = pow((_660 - _651) / (_652 - _651), 0.5);
        _659 = (_659 * (_656 - 1.0)) / _656;
        vec4 _684 = vec4(_643, _659, 0.0);
        vec3 _710 = textureLod(_693, vec4(_684.xyz, 0.0).xyz, vec4(_684.xyz, 0.0).w).xyz;
        _627 = vec4(_710.x, _710.y, _710.z, _627.w);
        vec2 _713 = textureLod(_714, vec4(_684.xyz, 0.0).xyz, vec4(_684.xyz, 0.0).w).xy;
        _627.w = _713.x;
        _629 = _713.y;
    }
    if ((_631 & 2u) != 0u)
    {
        vec4 _742 = vec4(0.0);
        vec3 _743 = _205._m4.xyz;
        float _748 = _624;
        vec4 _750 = _205._m7;
        float _753 = 1.0;
        bool _754 = false;
        float _747 = _40(_748, _750, _753, _754);
        vec3 _756 = mix(_205._m27.xyz, _205._m28.xyz, vec3(_616.x * _205._m29.z));
        vec3 _773 = mix(_205._m30.xyz, _205._m31.xyz, vec3(_616.x * _205._m29.z));
        vec3 _789 = mix(_773, _756, vec3(1.0 - (_616.y * _205._m29.w)));
        vec4 _800 = vec4(0.0);
        vec3 _801 = normalize(_789);
        float _804 = _801.z;
        _800.x = clamp(_18(_804) / 3.1415927410125732421875, 0.00390625, 0.99609375);
        float _813 = _801.y;
        float _816 = _801.x;
        _800.y = _29(_813, _816) / 6.283185482025146484375;
        _800.z = sqrt(_747 * _205._m32.w);
        _800.z = clamp(_800.z, 0.015625, 0.984375);
        vec3 _843 = textureLod(_836, _800.xyz, _800.w).xyz;
        _742 = vec4(_843.x, _843.y, _843.z, _742.w);
        vec3 _852 = _583.xyz + (_742.xyz * _629);
        _583 = vec4(_852.x, _852.y, _852.z, _583.w);
    }
    if ((_631 & 4u) != 0u)
    {
        vec3 _868 = (_583.xyz * _627.w) + _627.xyz;
        _583 = vec4(_868.x, _868.y, _868.z, _583.w);
    }
    float _871 = _583.w;
    _583.w = _10(_871);
    vec3 _880 = _583.xyz * _583.w;
    _583 = vec4(_880.x, _880.y, _880.z, _583.w);
    _883 = vec4(0.0);
    _884 = vec4(0.0);
    if (_205._m33.w > 0.0)
    {
        vec2 _891 = gl_FragCoord.xy * _205._m23.xy;
        bool _898 = (gl_FragCoord.z < TEXTURE_LOD(_901, vec4(_891, 0.0, 0.0).xy, vec4(_891, 0.0, 0.0).w).x) ? true : false;
        if (_898 == false)
        {
            _883 = _583;
        }
        _583 *= float(_898 == true);
        _884.x = _583.w;
    }
}

